Attribute VB_Name = "FONCTION_TEXTE"
Option Explicit

'Public Const Pi = 3.14159265358979
Public PI As Double
Public RADTODEG As Double
Public DEGTORAD As Double

Public Const INFINITY As Double = 9E+99

Public Type couleur
  valeur As Long
End Type

'--------------
' 3 couleurs
'-------------
Public Type CouleurRVB
  Rouge As Long
  Vert As Long
  Bleu As Long
End Type

Public Fichier_Librairie As String ' fichier dat Librairie ( definition Librairie )

Public Declare Sub SetWindowPos Lib "User32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long)

'INI File Functions
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As String, ByVal lpFileName As String) As Long
Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As Any, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Declare Function GetPrivateProfileInt Lib "kernel32" Alias "GetPrivateProfileIntA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Long, ByVal lpFileName As String) As Long



'Angle entre 2 Vecteurs forms de 3 point ( attention ne gre pas de valeu + ou -)
Function Angle3Pt(ByRef Po1 As Point3, ByRef Po2 As Point3, ByRef Po3 As Point3) As Double
Dim VEC1 As Point3
Dim VEC2 As Point3

VEC1 = VecSub(Po1, Po2)
VEC2 = VecSub(Po2, Po3)
If Distance(Po3, Po2) = 0 Or Distance(Po1, Po2) = 0 Then
    Angle3Pt = 0
Else
    If Distance(Po1, Po3) = 0 Then
        Angle3Pt = 180
    Else
        Angle3Pt = RADTODEG * (ACOS((VEC1.X * VEC2.X + VEC1.Y * VEC2.Y + VEC1.Z * VEC2.Z) / (Distance(Po3, Po2) * Distance(Po1, Po2))))
    End If
End If
                    
End Function

Function Atan2(ByVal X, ByVal Y)
    'On Error Resume Next
    '0 a PI
    If Y = 0 Then
        If X = 0 Then
            Atan2 = 0
        ElseIf X > 0 Then
            Atan2 = 0 'PI / 2
        Else
            Atan2 = PI '-PI / 2
        End If
    ElseIf X = 0 Then
        If Y > 0 Then
            Atan2 = PI / 2
        Else
            Atan2 = -PI / 2
        End If
    ElseIf X > 0 Then
        Atan2 = Atn(Y / X)
    Else
        Atan2 = (PI - Atn(Abs(Y) / Abs(X))) * Sgn(Y)
    End If
End Function


'****************************************************************
' Name: A 'strtok' function for VB
' Description:I wrote four functions to tokenize strings. He
'     re they are...
'The functions work like this TokLeftLeft finds the leftmost token and
'then returns the left part of the string (empty if not there). You
'can figure out the rest. Note that if the token is more than 1 character
'then the function will always return "".
'****************************************************************
Public Function TokLeftLeft(ByRef Source As String, ByRef token As String) As String

       Dim I As Integer
       Dim TokLeft As String
       TokLeft = Source

              For I = 1 To Len(Source)

                            If Mid(Source, I, 1) = token Then
                                   TokLeftLeft = Left(Source, I - 1)
                                   Exit Function
                            End If

              Next I

End Function
Public Function TokLeftRight(ByRef Source As String, ByRef token As String) As String

       Dim I As Integer
       Dim TokRight As String
       TokRight = Source

              For I = 1 To Len(Source)

                            If Mid(Source, I, 1) = token Then
                                   TokLeftRight = Right(Source, Len(Source) - I)
                                   Exit Function
                            End If

              Next I

End Function
Public Function TokRightLeft(ByRef Source As String, ByRef token As String) As String

       Dim I As Integer

       TokRightLeft = ""

              For I = Len(Source) To 1 Step -1

                            If Mid(Source, I, 1) = token Then
                                   TokRightLeft = Left(Source, I - 1)
                                   Exit Function
                            End If

              Next I

End Function
Public Function TokRightRight(ByRef Source As String, ByRef token As String) As String

       Dim I As Integer
       TokRightRight = ""

              For I = Len(Source) To 1 Step -1

                            If Mid(Source, I, 1) = token Then
                                   TokRightRight = Right(Source, Len(Source) - I)
                                   Exit Function
                            End If

              Next I

End Function



'****************************************************************
' Name: mReplaceCharacter
' Description:Replaces all instances of substring A with sub
'     string B in a string
' By: Ian Ippolito
'
' Inputs:strString==string to do replacing on
'strOrigChar==orig substring
'strReplaceChar==substring to replace orig substring

' Returns:strString after replacing all instances of strOrigChar with strReplaceChar
' Assumes:None
' Side Effects:None
'
'Code provided by Planet Source Code(tm) 'as is', without
'     warranties as to performance, fitness, merchantability,
'     and any other warranty (whether expressed or implied).
'****************************************************************
Function mReplaceCharacter(ByRef strOrigChar, ByRef strReplaceChar, ByVal strString)

       '     '**********************************
       '     'changes all strOrigChar
       '     ' to
       '     ' in strString
       '     '**********************************
       Dim strResult
       strResult = ""
       '     'traverse string
       Dim intIndex
        For intIndex = 1 To Len(strString)

              If (Mid(strString, intIndex, Len(strOrigChar)) = strOrigChar) Then
                                        '*************
                                        'match found
                                        '*************
                                        'MsgBox "found in" + strString
                                        strResult = strResult + strReplaceChar
                                        intIndex = intIndex + Len(strOrigChar) - 1
                                Else
                                        '*************
                                        'no match
                                        '*************
                     strResult = strResult + Mid(strString, intIndex, 1)
              End If

Next

mReplaceCharacter = strResult
End Function
Function Longueur(ByRef P1 As Point3) As Double
  Longueur = Sqr((P1.X ^ 2) + (P1.Y ^ 2) + (P1.Z ^ 2))
End Function

Function Distance(ByRef P1 As Point3, ByRef P2 As Point3) As Double
    Distance = Sqr((P2.X - P1.X) ^ 2 + (P2.Y - P1.Y) ^ 2 + (P2.Z - P1.Z) ^ 2)
End Function
'Addition de vecteur
Function VecAdd(ByRef P1 As Point3, ByRef P2 As Point3, Optional f As Double = 1) As Point3
 VecAdd.X = P1.X + f * P2.X
 VecAdd.Y = P1.Y + f * P2.Y
 VecAdd.Z = P1.Z + f * P2.Z
End Function

'Produit Scalaire
Function Dot(ByRef p As Point3, ByRef q As Point3) As Double
    Dot = p.X * q.X + p.Y * q.Y + p.Z * q.Z
End Function
Function SubVect(ByRef P1 As Point3, ByRef P2 As Point3, ByRef f As Double) As Point3
 SubVect.X = P1.X - P2.X * f
 SubVect.Y = P1.Y - P2.Y * f
 SubVect.Z = P1.Z - P2.Z * f
End Function

'Produit vectoriel
Function VecProd(ByRef P1 As Point3, ByRef P2 As Point3) As Point3
Dim P4 As Point3

 P4.X = (P1.Y * P2.Z) - (P1.Z * P2.Y)
 P4.Y = (P1.Z * P2.X) - (P1.X * P2.Z)
 P4.Z = (P1.X * P2.Y) - (P1.Y * P2.X)
 VecProd = P4
 
End Function


' Soustraction de vecteur
Function VecSub(ByRef P1 As Point3, ByRef P2 As Point3) As Point3
 VecSub.X = P1.X - P2.X
 VecSub.Y = P1.Y - P2.Y
 VecSub.Z = P1.Z - P2.Z
End Function
'rcupration du vecteur normal de 3 points
Function NormVec(ByRef P1 As Point3, ByRef P2 As Point3, ByRef P3 As Point3) As Point3
 NormVec = VecteurUnitaire(VecProd(VecSub(P1, P2), VecSub(P3, P2)))
End Function

' transforme un vecteur en vecteur unitaire
Function VecteurUnitaire(ByRef P1 As Point3) As Point3
Dim Norm As Double
Norm = Sqr((P1.X) ^ 2 + (P1.Y) ^ 2 + (P1.Z) ^ 2)
If Norm = 0 Then
    Exit Function
End If
    
    VecteurUnitaire.X = P1.X / Norm
    VecteurUnitaire.Y = P1.Y / Norm
    VecteurUnitaire.Z = P1.Z / Norm
End Function
' Coordones du point Milieu
Function PointMillieu(ByRef P1 As Point3, ByRef P2 As Point3) As Point3
 PointMillieu.X = 0.5 * (P1.X + P2.X)
 PointMillieu.Y = 0.5 * (P1.Y + P2.Y)
 PointMillieu.Z = 0.5 * (P1.Z + P2.Z)
End Function
'****************************************************************
' Name: Round
'
' Inputs:DP is the decimal place to round to (0 to 14) e.g
' Round (3.56376, 3) will give the result 3.564
' Round (3.56376, 1) will give the result 3.6
' Round (3.56376, 0) will give the result 4
' Round (3.56376, 2) will give the result 3.56
' Round (1.4999, 3) will give the result 1.5
' Round (1.4899, 2) will give the result 1.49
' Returns:None
' Assumes:None
' Side Effects:None
'
'****************************************************************
Function Round(x1 As Double, DP As Integer) As Double
    Round = Int((x1 * 10 ^ DP) + 0.5) / 10 ^ DP
End Function



Function ACOS(Ang)
    Select Case Ang
        Case 1
            ACOS = 0 '0
        Case -1
            ACOS = 4 * Atn(1) 'PI
        Case Else
            ACOS = 2 * Atn(1) - Atn(Ang / Sqr(1 - Ang * Ang))
    End Select
End Function

Function ASIN(Ang)
    Select Case Ang
        Case 1
            ASIN = 2 * Atn(1)
        Case -1
            ASIN = -2 * Atn(1)
        Case Else
            ASIN = Atn(Ang / Sqr(1 - Ang * Ang))
    End Select
End Function

'Angle entre 2 Vecteurs forms concourant en 0
Function AngleVect(ByRef Po1 As Point3, ByRef Po2 As Point3, ByRef Normal As Point3) As Double
Dim VEC1 As Point3
Dim VEC2 As Point3
Dim Po3 As Point3
Dim Signe As Double

VEC1 = Po1
VEC2 = Po2
If Longueur(VEC1) = 0 Or Longueur(VEC2) = 0 Then
    AngleVect = 0
Else
    If Distance(Po1, Po2) = 0 Then
        AngleVect = 0
    Else

        Po3 = VecProd(VEC1, VEC2)
        Signe = Sgn(Dot(Po3, Normal))
        
        'Debug.Print " Dot/Normal         | " & Signe
        
        'Debug.Print " Po3         | " & Format(Po3.x, "#,###0.0000") & " | " & Format(Po3.y, "#,###0.0000") & " | " & Format(Po3.Z, "#,###0.0000") & " | "
        AngleVect = Signe * RADTODEG * (ACOS((VEC1.X * VEC2.X + VEC1.Y * VEC2.Y + VEC1.Z * VEC2.Z) / (Longueur(VEC1) * Longueur(VEC2))))
    End If
End If
                    
End Function




'Autre Fonction avec le mme resultat
Public Function GetRVB(Couleur_long As Long) As CouleurRVB
Dim TempColor As CouleurRVB
    
    TempColor.Bleu = Int(Couleur_long / 65536)
    TempColor.Vert = Int((Couleur_long - (65536 * TempColor.Bleu)) / 256)
    TempColor.Rouge = Couleur_long - (65536 * TempColor.Bleu + 256 * TempColor.Vert)

GetRVB = TempColor
  
End Function
'-----------------------------------------------------------
' FUNCTION: FileExists
' Determines whether the specified file exists
'
' IN: [strPathName] - file to check for
'
' Returns: True if file exists, False otherwise
'-----------------------------------------------------------
'
Public Function FileExists(ByVal strPathName As String) As Integer
    Dim intFileNum As Integer

    On Error Resume Next

    '
    'Remove any trailing directory separator character
    '
    If Right$(strPathName, 1) = "\" Then
        strPathName = Left$(strPathName, Len(strPathName) - 1)
    End If

    '
    'Attempt to open the file, return value of this function is False
    'if an error occurs on open, True otherwise
    '
    intFileNum = FreeFile
    Open strPathName For Input As intFileNum

    FileExists = IIf(Err, False, True)

    Close intFileNum

    Err = 0
End Function

Function Trans_Matrix(Mx2() As Double, P0 As Point3, P1 As Point3) As Point3
'Calcul suivant la  matrice de transformation
               Trans_Matrix.X = Mx2(0, 0) * P1.X + Mx2(0, 1) * P1.Y + Mx2(0, 2) * P1.Z + P0.X
               Trans_Matrix.Y = Mx2(1, 0) * P1.X + Mx2(1, 1) * P1.Y + Mx2(1, 2) * P1.Z + P0.Y
               Trans_Matrix.Z = Mx2(2, 0) * P1.X + Mx2(2, 1) * P1.Y + Mx2(2, 2) * P1.Z + P0.Z
End Function


Function Trans_Matrix_1_16(ByRef Matrix() As Double, ByRef P1 As Point3) As Point3
'Calcul suivant la  matrice de transformation
               Trans_Matrix_1_16.X = Matrix(1) * P1.X + Matrix(5) * P1.Y + Matrix(9) * P1.Z + Matrix(13)
               Trans_Matrix_1_16.Y = Matrix(2) * P1.X + Matrix(6) * P1.Y + Matrix(10) * P1.Z + Matrix(14)
               Trans_Matrix_1_16.Z = Matrix(3) * P1.X + Matrix(7) * P1.Y + Matrix(11) * P1.Z + Matrix(15)
End Function


' Suppression dans une chaine de charactres des ventuels charactres parasite

Function Nettoyage_texte(Chaine As String, Optional Suppress_double_space As Boolean = False) As String

  Dim pos_char As Integer
  
    Chaine = mReplaceCharacter(Chr(9), Chr(32), Chaine) 'Remplace les tabulations par des espaces
    Chaine = LTrim(Chaine) ' Suprime les espaces de gauche.
    Chaine = mReplaceCharacter(Chr(13), "", Chaine) 'Supprime Chr(13)
    Chaine = mReplaceCharacter(Chr(10), "", Chaine) 'Supprime Chr(10)
    Chaine = RTrim(Chaine) ' Suprime les espaces de droite.
    
again:
    pos_char = InStr(1, Chaine, Chr(32) & Chr(32))
    If pos_char > 1 And Suppress_double_space Then
        Chaine = mReplaceCharacter(Chr(32) & Chr(32), Chr(32), Chaine) 'Remplace les espaces doubles
        GoTo again
    End If
    
    ' corrige le ( sans espace avant pour analyse du select case
    pos_char = InStr(1, Chaine, "(")
    If pos_char > 1 Then
        If Mid$(Chaine, (pos_char - 1), 1) <> " " Then
            Chaine = Left(Chaine, pos_char - 1) + " (" + Right(Chaine, Len(Chaine) - pos_char)
        End If
    End If
    
    
    Nettoyage_texte = Chaine
End Function

Function mfncParseString(strIn As String, intOffset As Integer, strDelimiter As String) As String
       '*** DESCRIPTION:Parses the passed string, returning the value indicated
       '     '***by the offset specified, eg: the string "Hello, World ","
       '     '***offset 2 = "World".
       '     '*** RETURNS:See description.
       '     '*** NOTE: The offset starts at 1 and the delimiter is the Character
       '     '***which separates the elements of the string.
       '     'Trap any bad calls

              If Len(strIn) = 0 Or intOffset = 0 Then
                     mfncParseString = ""
                     Exit Function
              End If

       '     'Declare local variables
       Dim intStartPos As Integer
       ReDim intDelimPos(10) As Integer
       Dim intStrLen As Integer
       Dim intNoOfDelims As Integer
       Dim intCount As Integer
       Dim strQuotationMarks As String
       Dim intInsideQuotationMarks As Integer
       strQuotationMarks = Chr(34) & Chr(147) & Chr(148)
       intInsideQuotationMarks = False

              For intCount = 1 To Len(strIn)
                     'If character is a double-quote then toggle the In Quotation
                     '      flag

                            If InStr(strQuotationMarks, Mid$(strIn, intCount, 1)) <> 0 Then
                                   intInsideQuotationMarks = (Not intInsideQuotationMarks)
                            End If


                            If (Not intInsideQuotationMarks) And (Mid$(strIn, intCount, 1) = strDelimiter) Then
                                   intNoOfDelims = intNoOfDelims + 1
                                   '     'If array filled then enlarge it, keeping existing contents

                                          If (intNoOfDelims Mod 10) = 0 Then
                                                 ReDim Preserve intDelimPos(intNoOfDelims + 10)
                                          End If

                                   intDelimPos(intNoOfDelims) = intCount
                            End If

              Next intCount

       '     'Handle request for value not present (over-run)

              If intOffset > (intNoOfDelims + 1) Then
                     mfncParseString = ""
                     Exit Function
              End If

       '     'Handle boundaries of string

              If intOffset = 1 Then
                     intStartPos = 1
              End If

       '     'Requesting last value - handle null

              If intOffset = (intNoOfDelims + 1) Then

                            If Right$(strIn, 1) = strDelimiter Then
                                   intStartPos = -1
                                   intStrLen = -1
                                   mfncParseString = ""
                                   Exit Function
                            Else
                                   intStrLen = Len(strIn) - intDelimPos(intOffset - 1)
                            End If

              End If

       'Set start and length variables if not handled by boundary c
       '     heck above

              If intStartPos = 0 Then
                     intStartPos = intDelimPos(intOffset - 1) + 1
              End If


              If intStrLen = 0 Then
                     intStrLen = intDelimPos(intOffset) - intStartPos
              End If

       '     'Set the return string
       mfncParseString = Mid$(strIn, intStartPos, intStrLen)
End Function

'****************************************************************
' Name: GetFilename
' Description:This function takes a fully qualified filename
'     /path and parses it into individual parts and returns one of
'      the the parts (drive, path, filename, or extension) based o
'     n its parameters. Useful to use in building strings and mani
'     pulating filenames. Complete error handling. Supports long f
'     ilenames.
' By: Chris Cubley
'
' Inputs:GetFilename(FName As String, ReturnType As Integer)
'FName is a string containing the filename and path.
'ReturnType tells the function what to return.
'0 -- Returns the drive letter
'1 -- Returns the directory path
'2 -- Returns the filename (without the extension)
'3 -- Returns the extension
' Returns:The function returns a string containing the portion of the filename/path you specified in ReturnType. If the string did not contain the requested part, it returns a zero-length string.
' Assumes:Put it in a bas file and call the function, that's all there is to it. Used like Any other function.
' Side Effects:If ReturnType is not a valid value (i.e. not 0-3), then the function returns no value and raises and error with error code 1.
'
'Code provided by Planet Source Code(tm) 'as is', without
'     warranties as to performance, fitness, merchantability,
'     and any other warranty (whether expressed or implied).
'****************************************************************
Public Function FormatFileName(ByVal TempPath As String, ReturnType As Integer)

       Dim DriveLetter As String
       Dim DirPath As String
       Dim FName As String
       Dim Extension As String
       Dim PathLength As Integer
       Dim ThisLength As Integer
       Dim Offset As Integer
       Dim FileNameFound As Boolean

              If ReturnType <> 0 And ReturnType <> 1 And ReturnType <> 2 And ReturnType <> 3 Then
                     Err.Raise 1
                     Exit Function
              End If

       DriveLetter = ""
       DirPath = ""
       FName = ""
       Extension = ""

              If Mid(TempPath, 2, 1) = ":" Then ' Find the drive letter.
                     DriveLetter = Left(TempPath, 2)
                     TempPath = Mid(TempPath, 3)
              End If

       PathLength = Len(TempPath)

              For Offset = PathLength To 1 Step -1 ' Find the next delimiter.
                     Select Case Mid(TempPath, Offset, 1)
                      Case ".": ' This indicates either an extension or a . or a ..
                      ThisLength = Len(TempPath) - Offset
                      If ThisLength >= 1 Then ' Extension
                      Extension = Mid(TempPath, Offset, ThisLength + 1)
                      End If
                      TempPath = Left(TempPath, Offset - 1)
                      Case "\": ' This indicates a path delimiter.
                      ThisLength = Len(TempPath) - Offset
                      If ThisLength >= 1 Then ' Filename
                      FName = Mid(TempPath, Offset + 1, ThisLength)
                      TempPath = Left(TempPath, Offset)
                      FileNameFound = True
                      Exit For
                      End If
                      Case Else
              End Select

Next Offset


If FileNameFound = False Then
       FName = TempPath
Else
       DirPath = TempPath
End If


If ReturnType = 0 Then
       FormatFileName = DriveLetter
ElseIf ReturnType = 1 Then
       FormatFileName = DirPath
ElseIf ReturnType = 2 Then
       FormatFileName = FName
ElseIf ReturnType = 3 Then
       FormatFileName = Extension
End If

End Function

Function GetFileNoExtension(FileName As String) As String
' Returns filename from filename.ext
    Dim I As Integer
    GetFileNoExtension = FileName     ' Just in case there is no "." in the file
    For I = 1 To Len(FileName)
        If Mid$(FileName, Len(FileName) - I, 1) = "." Then
            GetFileNoExtension = Mid$(FileName, 1, Len(FileName) - (I + 1))
            Exit For
        End If
    Next
End Function



'****************************************************************
' Name: .INI read/write routines
' Description:.INI read/write routines
'mfncGetFromIni-- Reads from an *.INI file strFileName(full path & file name)
'mfncWriteIni--Writes to an *.INI file called strFileName (full path & file name)
'****************************************************************
Function mfncGetFromIni(strSectionHeader As String, strVariableName As String, strFileName As String) As String
       '*** DESCRIPTION:Reads from an *.INI file strFileName (fullpath & file name)
       '     '*** RETURNS:The string stored in [strSectionHeader], line  beginning strVariableName=
       '     '*** NOTE: Requires declaration of API call GetPrivateProfileString
       '     'Initialise variable
       Dim strReturn As String
       '     'Blank the return string
       strReturn = String(255, Chr(0))
       '     'Get requested information, trimming the returned string
       mfncGetFromIni = Left$(strReturn, GetPrivateProfileString(strSectionHeader, ByVal strVariableName, "", strReturn, Len(strReturn), strFileName))
End Function
Function mfncWriteIni(strSectionHeader As String, strVariableName As String, strValue As String, strFileName As String) As Integer
       '*** DESCRIPTION:Writes to an *.INI file called strFileName
       '     (full       path & file name)
       '*** RETURNS:Integer indicating failure (0) or success (other)       to write
       '     '*** NOTE: Requires declaration of API call     WritePrivateProfileString
       '     'Call the API
       mfncWriteIni = WritePrivateProfileString(strSectionHeader, strVariableName, strValue, strFileName)
End Function
Function mfncDeleteIniKey(strSectionHeader As String, strVariableName As String, strFileName As String) As Integer
       '*** DESCRIPTION:Writes to an *.INI file called strFileName
       '     (full       path & file name)
       '*** RETURNS:Integer indicating failure (0) or success (other)       to write
       '     '*** NOTE: Requires declaration of API call     WritePrivateProfileString
       '     'Call the API
       mfncDeleteIniKey = WritePrivateProfileString(strSectionHeader, strVariableName, 0&, strFileName)
End Function
Function mfncDeleteIniSection(strSectionHeader As String, strFileName As String) As Integer
       '*** DESCRIPTION:Writes to an *.INI file called strFileName
       '     (full       path & file name)
       '*** RETURNS:Integer indicating failure (0) or success (other)       to write
       '     '*** NOTE: Requires declaration of API call     WritePrivateProfileString
       '     'Call the API
       mfncDeleteIniSection = WritePrivateProfileString(strSectionHeader, 0&, 0&, strFileName)
End Function
Public Function GetIniInt(strSectionHeader As String, Key As String, strFileName As String, Optional Default As Long) As Long
    GetIniInt = GetPrivateProfileInt(strSectionHeader, Key, Default, strFileName)
End Function


Sub Affiche_Message(Texte As String)
Dim J As Integer
        Feat_Frm.MessageLOG.Cls
        Feat_Frm.MessageLOG.CurrentY = 0
        DoEvents
        Feat_Frm.MessageLOG.Print Texte
        
End Sub

' Efface et rinittialise la fentre de sortie des infos
Sub MessageLOG_CLS()

    Feat_Frm.MessageLOG.Cls
    Feat_Frm.MessageLOG.CurrentY = 0
    
End Sub
' Ecrit dans la fenetre les infos
Sub MessageLOG_Print(Chaine As String)

    If Feat_Frm.MessageLOG.CurrentY >= Feat_Frm.MessageLOG.ScaleHeight Then
        Call MessageLOG_CLS
    End If
    
    Feat_Frm.MessageLOG.Print Chaine

End Sub
