Attribute VB_Name = "IMPORT_FORMAT_FEATURE"
Option Explicit

Public Type FeatureFamilly
    Nb As Long
    NOM As String
    REf As Integer  'Ref servant de ref feature et numero image
End Type

'---------------------
' Relecture des features
'------------------------
Public Type FEATURE
   NOM As String
   COMMENTAIRE As String
   NB_Total As Long
   FAM(1 To 255) As FeatureFamilly  'FAMILLE DE FEATURE
End Type



Public RelectureFeaturefeat As FEATURE

Sub Affiche_resultat_relecture(RelectureFeature As FEATURE)
Dim I As Integer
Dim REf As Integer




REf = 1
Feat_Frm.TreeViewTOOL.Nodes(REf).Text = "Relecture " & RelectureFeature.NB_Total & " Feature(s)"

   Call Affiche_Arbre_feature(REf, RelectureFeature.FAM)

End Sub
Sub Affiche_Arbre_feature(REf As Integer, Tableau() As FeatureFamilly)
Dim I As Integer

   REf = REf + 1
   'Tool_Frm.TreeViewTOOL.Nodes.Add "LIB", tvwChild, Famille, "Famille " & Famille, 2, 2
   For I = 1 To 4
      If Tableau(I).NOM <> "" Then
            REf = REf + 1
            Feat_Frm.TreeViewTOOL.Nodes(REf).Text = Tableau(I).NOM & " -> " & Tableau(I).Nb & " Feature(s)"
      End If
   Next I
End Sub


Sub Init_ArbreFeature(RelectureFeature As FEATURE)
Dim I As Integer

    Call InitTypeFeatures(RelectureFeature)

   ' Racine
   Feat_Frm.TreeViewTOOL.Nodes.Add , tvwLast, "LIB", "Librairie Feature", 1, 1
   
   'Famille
   Feat_Frm.TreeViewTOOL.Nodes.Add "LIB", tvwChild, "Feature3D", "Famille " & "Feature3D", 2, 2
   For I = 1 To 255
      If RelectureFeature.FAM(I).NOM <> "" Then
            Feat_Frm.TreeViewTOOL.Nodes.Add "Feature3D", tvwChild, RelectureFeature.FAM(I).NOM, RelectureFeature.FAM(I).NOM, 3, 3
      End If
   Next I
   
End Sub

Sub RAZ_NB_Feature(RelectureFeature As FEATURE)
Dim I As Integer

    With RelectureFeature
        .COMMENTAIRE = ""
        .NOM = ""
        .NB_Total = 0
    
        For I = 1 To 255
         .FAM(I).Nb = 0
        Next I
    End With


End Sub
Sub InitTypeFeatures(RelectureFeature As FEATURE)
Dim I As Integer

Call RAZ_NB_Feature(RelectureFeature)

With RelectureFeature
        '*****************************************************
        'TRAITEMENT DES "TYPE1"
        '*****************************************************
          .FAM(1).NOM = "TYPE1"
        '*****************************************************
        'TRAITEMENT DES "TYPE2"
        '*****************************************************
          .FAM(2).NOM = "TYPE2"
        '*****************************************************
        'TRAITEMENT DES "TYPE2"
        '*****************************************************
          .FAM(3).NOM = "TYPE3"
End With

End Sub



' fichier en entr
'
Function Lecture_fichier_feat(ByVal fic_in As String) As Integer
Dim errorcode As Integer
Dim Donneslues As String

Dim Traitement_chaine As String
Dim Section As String
Dim Chg_fichier As Boolean
Dim Current_Feature As Integer
Dim Current_Segment As Integer
Dim indice As Integer
Dim Section_Features As String
Dim NB_features As Integer
Dim Type_feature As String


Debut:

Chg_fichier = False
On Error Resume Next


    If LenB(fic_in) = 0 Or LenB(Dir(fic_in)) = 0 Then
        errorcode = 98
        GoTo ErrorHandler
    End If

' RAZ info sur nb lib feature

Call RAZ_NB_Feature(RelectureFeaturefeat)
Open fic_in For Input As #1   ' Ouvre le fichier en lecture
Section = "NONE"

  
'Initialisation
BIBLIOTHEQUE3D.FICHIER = fic_in
BIBLIOTHEQUE3D.NOM = mfncGetFromIni("FICHIER", "Fichier", fic_in)
BIBLIOTHEQUE3D.COMMENTAIRE = mfncGetFromIni("FICHIER", "Commentaire", fic_in)
NB_features = val(mfncGetFromIni("FICHIER", "NbFeatures", fic_in))



' Tableau de gomtrie 3d
BIBLIOTHEQUE3D.NB_Poche_Circulaire3D = 0
BIBLIOTHEQUE3D.NB_Poche_Rectangulaire3D = 0
BIBLIOTHEQUE3D.NB_Poche_Oblong3D = 0
ReDim BIBLIOTHEQUE3D.TAB_Poche_Circulaire3D(0) ' Tableau des Circulaires
ReDim BIBLIOTHEQUE3D.TAB_Poche_Rectangulaire3D(0) ' Tableau des rectangles
ReDim BIBLIOTHEQUE3D.TAB_Poche_Oblong3D(0) ' Tableau des Oblongs


'*****************************************************
'TRAITEMENT DES FEATURES
'*****************************************************
For indice = 1 To NB_features
    Section_Features = "FEAT" & indice
    Type_feature = mfncGetFromIni(Section_Features, "TYPE_FEATURE", fic_in)
    Select Case Type_feature
     
      Case "TYPE1"
            Call Import_FEAT(fic_in, Section_Features, Current_Feature)
            RelectureFeaturefeat.FAM(1).Nb = RelectureFeaturefeat.FAM(1).Nb + 1
            RelectureFeaturefeat.NB_Total = RelectureFeaturefeat.NB_Total + 1
    
      Case "TYPE2"
            Call Import_FEAT(fic_in, Section_Features, Current_Feature)
            RelectureFeaturefeat.FAM(2).Nb = RelectureFeaturefeat.FAM(2).Nb + 1
            RelectureFeaturefeat.NB_Total = RelectureFeaturefeat.NB_Total + 1
            
      Case "TYPE3"
            Call Import_FEAT(fic_in, Section_Features, Current_Feature)
            RelectureFeaturefeat.FAM(3).Nb = RelectureFeaturefeat.FAM(3).Nb + 1
            RelectureFeaturefeat.NB_Total = RelectureFeaturefeat.NB_Total + 1
            
      Case Else
        Affiche_Message "Type de feature non trait" & Type_feature
    End Select
Next indice

      

errorcode = 0

Lecture_fichier_feat = errorcode
Exit Function
  
ErrorHandler:
    '   This is entered only when an error occures
    Select Case errorcode
        Case 0                      '   Unknown error
            Reset                   '   Close any open files
            Lecture_fichier_feat = errorcode           '   Assign error code 4 to the function
        Case Else                   '   Assign error code value to the function
            Reset                   '   Close any open files
            Lecture_fichier_feat = errorcode
    End Select
    
End Function


Private Sub Import_FEAT(fic_in As String, Section_Features As String, ByRef Current_Feature As Integer)
Dim PointC As Point3
Dim VX As Point3
Dim VY As Point3
Dim VZ As Point3
Dim Diametre As Double
Dim Diametre_Interieur As Double
Dim Largeur As Double
Dim Longueur As Double
Dim Hauteur As Double
Dim Rayon As Double
Dim PosF As FEAT_POSITION
Dim NB_forme As Integer
Dim Angle_Lamage As Double
Dim Rayon_Lamage As Double
Dim Diametre_Lamage As Double
Dim Prof_Lamage As Double
   
           ' Ajouter un Feature
           Current_Feature = Current_Feature + 1
           BIBLIOTHEQUE3D.NB_FEAT = Current_Feature
          
           'Extraction des dimensions
            Diametre = val(mfncGetFromIni(Section_Features, "DIAMETRE", fic_in))
            Diametre_Interieur = val(mfncGetFromIni(Section_Features, "DIAM_2", fic_in))
            
            Longueur = val(mfncGetFromIni(Section_Features, "LONGUEUR", fic_in))
            Hauteur = val(mfncGetFromIni(Section_Features, "HAUTEUR", fic_in))
            Rayon = val(mfncGetFromIni(Section_Features, "RAYON", fic_in))
            Largeur = val(mfncGetFromIni(Section_Features, "LARGEUR", fic_in))
            
' Traitement du lamage
Angle_Lamage = val(mfncGetFromIni(Section_Features, "ANGLE_LAMAGE", fic_in))
Rayon_Lamage = val(mfncGetFromIni(Section_Features, "RAYON_LAMAGE", fic_in))
Diametre_Lamage = val(mfncGetFromIni(Section_Features, "DIAMETRE_LAMAGE", fic_in))
Prof_Lamage = val(mfncGetFromIni(Section_Features, "PROF_LAMAGE", fic_in))

            'Cas de l'oblong
            If Largeur = 0 And Diametre = 0 Then
                           Largeur = 2 * Rayon
            End If
              
           PosF = Get_FEAT_POS(fic_in, Section_Features)
            
            PointC = PosF.POS
            VX = VecteurUnitaire(PosF.DIR_X)
            VY = VecteurUnitaire(PosF.DIR_Y)
            VZ = VecteurUnitaire(PosF.DIR_Z)
          
           
           
             If Diametre > 0 Then
                    ' Ajouter une poche circulaire sous formes IGES
                    BIBLIOTHEQUE3D.NB_Poche_Circulaire3D = BIBLIOTHEQUE3D.NB_Poche_Circulaire3D + 1
                    NB_forme = UBound(BIBLIOTHEQUE3D.TAB_Poche_Circulaire3D()) + 1
                    ReDim Preserve BIBLIOTHEQUE3D.TAB_Poche_Circulaire3D(NB_forme)
                           
                       With BIBLIOTHEQUE3D.TAB_Poche_Circulaire3D(NB_forme)
                                  .NOM = mfncGetFromIni(Section_Features, "NOM", fic_in)
                                  .COMMENTAIRE = Section_Features + " (" + mfncGetFromIni(Section_Features, "TYPE_FEATURE", fic_in) + ")"
                                  .Hauteur = Hauteur
                                  .Centre = PointC
                                  .Axes(0) = VX
                                  .Axes(1) = VY
                                  .Axes(2) = VZ
                                  .Rayon = Diametre / 2
                                  .Rayon_Fond = Diametre_Interieur / 2
                                  
                                  .Diametre_Lamage = Diametre_Lamage
                                  .Rayon_Lamage = Rayon_Lamage
                                  .Angle_Lamage = Angle_Lamage
                                  .Prof_Lamage = Prof_Lamage

                        End With
              Else
              
           


            
           If Largeur > (2 * Rayon) Then
                ' Ajouter un rectangle
                BIBLIOTHEQUE3D.NB_Poche_Rectangulaire3D = BIBLIOTHEQUE3D.NB_Poche_Rectangulaire3D + 1
                NB_forme = UBound(BIBLIOTHEQUE3D.TAB_Poche_Rectangulaire3D()) + 1
                ReDim Preserve BIBLIOTHEQUE3D.TAB_Poche_Rectangulaire3D(NB_forme)
                
                With BIBLIOTHEQUE3D.TAB_Poche_Rectangulaire3D(NB_forme)
                    .NOM = mfncGetFromIni(Section_Features, "NOM", fic_in)
                    .COMMENTAIRE = Section_Features + " (" + mfncGetFromIni(Section_Features, "TYPE_FEATURE", fic_in) + ")"
                    .Centre = PointC
                    .Axes(0) = VX
                    .Axes(1) = VY
                    .Axes(2) = VZ
                    .Longueurs(0) = Longueur
                    .Longueurs(1) = Largeur
                    .Longueurs(2) = Hauteur
                    .Rayon = Rayon
                End With
           Else
                ' Ajouter un Poche_Oblong3D
                BIBLIOTHEQUE3D.NB_Poche_Oblong3D = BIBLIOTHEQUE3D.NB_Poche_Oblong3D + 1
                NB_forme = UBound(BIBLIOTHEQUE3D.TAB_Poche_Oblong3D()) + 1
                ReDim Preserve BIBLIOTHEQUE3D.TAB_Poche_Oblong3D(NB_forme)
                With BIBLIOTHEQUE3D.TAB_Poche_Oblong3D(NB_forme)
                    .NOM = mfncGetFromIni(Section_Features, "NOM", fic_in)
                    .COMMENTAIRE = Section_Features + " (" + mfncGetFromIni(Section_Features, "TYPE_FEATURE", fic_in) + ")"
                    .Centre = PointC
                    .Axes(0) = VX
                    .Axes(1) = VY
                    .Axes(2) = VZ
                    .Longueurs(0) = Longueur
                    .Longueurs(1) = Largeur
                    .Longueurs(2) = Hauteur
                End With
           End If
           
           End If ' fin test sur diametre
End Sub


'----------------------------------------------------------------------------------------------------
' Relecture de la section FEAT pos Dfinition de la position d'un Feature
'----------------------------------------------------------------------------------------------------
Private Function Get_FEAT_POS(fic_in As String, Section_Features As String) As FEAT_POSITION
Dim Feat_pos_tempo As FEAT_POSITION
Dim PointZero As Point3

              With Feat_pos_tempo
                    .POS = Decodage_Pt3_feat(mfncGetFromIni(Section_Features, "3D_ORI", fic_in))
                    .DIR_Z = VecAdd(PointZero, Decodage_Pt3_feat(mfncGetFromIni(Section_Features, "3D_NOR", fic_in)), -1)
                    .DIR_Y = Decodage_Pt3_feat(mfncGetFromIni(Section_Features, "3D_DIR", fic_in))
                    .DIR_X = NormVec(PointZero, .DIR_Y, .DIR_Z)
              End With

Get_FEAT_POS = Feat_pos_tempo
End Function
Private Function Decodage_Pt3_feat(Chaine As String) As Point3
Dim Pt As Point3
Dim tabSplit() As String

On Error GoTo fin

    tabSplit = Split(Chaine, ";")
    Pt.X = val(tabSplit(0))
    Pt.Y = val(tabSplit(1))
    Pt.Z = val(tabSplit(2))
    
    Decodage_Pt3_feat = Pt
    Exit Function
    
fin:
        MsgBox "Erreur relecture point " & Chaine & " = <" & UBound(tabSplit) & "> Tab"
End Function

